/*
** conf.h
** Login : <julien@localhost>
** $Id$
** 
** Copyright Julien Perez (C) 2005 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#ifndef   	CONF_H_
# define   	CONF_H_


/*
 * Configuration File Primitives
 */

#define NB_CONF 16

typedef enum
  {
    CONF_UNKNOW             = 0x00,
    CONF_BIND               = 0X01,
    CONF_PORT               = 0x02,
    CONF_INCLUDE            = 0x03,
    CONF_PREFORK_PROCESS    = 0x04,
    CONF_LOG                = 0x05,
    CONF_ADD_RULE           = 0x06,
    CONF_BACKLOG            = 0x07,
    CONF_ENABLE_FILTER      = 0x08,
    CONF_DISABLE_FILTER     = 0x09,
    CONF_ENABLE_LOG_FILTER  = 0x0A,
    CONF_DISABLE_LOG_FILTER = 0x0B,
    CONF_WHITELIST          = 0x0C,
    CONF_WHITELIST_FILE     = 0x0D,
    CONF_CACHE_PEER         = 0x0E,
    CONF_DIRECT_CONNECT     = 0x0F
  }conf_node_type;


/*
 * Public Interface
 */

struct conf_node_t
{
  conf_node_type      type;
  char               *value;
  struct conf_node_t *next;
};
typedef struct conf_node_t conf_node_t;



int  conf_parse_file (char *file);
char *conf_get_node (conf_node_type node_type);
void conf_debug();
void conf_log();

#endif 	    /* !CONF_H_ */
