/*
** fstmatch.h
** 
** Copyright Perez Julien (C) 2005
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#ifndef   	FSTMATCH_H_
# define   	FSTMATCH_H_

/*
 * Public Interface
 */

/*
 * Fast Match Library
 *
 * The principle is simple, we contruct a N-Tree 
 * of all strings to match, the struct fstmatch_ctxt.
 * Then, we walk throught the N-Tree to match a pattern
 */


#define FST_MATCH_OK 1
#define FST_MATCH_KO 0

struct fstmatch_token
{
  char                   c;
  unsigned char          term;
  void                  *store_value;
  struct fstmatch_token *next;
  struct fstmatch_token *childs;
};
typedef struct fstmatch_token fstmatch_token;

struct fstmatch_ctxt
{
  fstmatch_token *lst_tokens;
  int nb_token;
};
typedef struct fstmatch_ctxt fstmatch_ctxt;

void  fstmatch_ctxt_init       (fstmatch_ctxt *ctxt);
void  fstmatch_addpattern      (fstmatch_ctxt *ctxt, char *pattern, void *store_value);

int   fstmatch_match           (fstmatch_ctxt *ctxt, char *pattern);
int   fstmatch_search_value    (fstmatch_ctxt *ctxt, char *pattern, void *store_value, int lenght);

void  fstmatch_ctxt_debug      (fstmatch_ctxt *ctxt);


#endif 	    /* !FSTMATCH_H_ */
