/*
** http_methods.h
** Login : <julien@localhost>
** $Id$
** 
** Copyright Julien Perez (C) 2005 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#ifndef   	HTTP_METHODS_H_
# define   	HTTP_METHODS_H_


#include "http.h"

/*
 * Public Interface
 */

/* HTTP structures debug primitives */
void  http_methods_req_debug  (http_req_t *req);
void  http_methods_resp_debug (http_resp_t *resp);

/* HTTP Field checking primitives */
int   http_is_field (http_field_t *lst_fields, field_type type, char *value);
char *http_method_search_field(http_field_t *lst_field, field_type type);

/* HTTP Field Manipulation */
http_field_t *http_methods_add_field(http_field_t *lst_fields, field_type type, char *value);
http_field_t *http_methods_rm_field(http_field_t *lst_fields, http_field_t *field);

/* HTTP structures initialisation and destruction */
void http_methods_init_req(http_req_t *req);
void http_methods_init_resp(http_resp_t *resp);

void http_methods_free_req(http_req_t *req);
void http_methods_free_resp(http_req_t *resp);


/* Fast identifying for header-type*/
void http_methods_fstmatch_initheader ();
int http_methods_fstmatch_getheadertype(char *header);

#endif 	    /* !HTTP_METHODS_H_ */
