/*
** tokenlib.h
** 
** Copyright Julien Perez (C) 2005 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#ifndef   	TOKENLIB_H_
# define   	TOKENLIB_H_

/*
 * Public Interface
 */

#define LIBSESSION_BUFFER_SIZE 2048

struct token_session_t
{
  int fd;
  unsigned char column_passed;
  int cursor;
  int size;
  unsigned char buffer[LIBSESSION_BUFFER_SIZE];
};
typedef struct token_session_t token_session_t;

/* Net I/O Buffering */

token_session_t    *token_init(int fd);

char *token_get_simple     (token_session_t *session);
char *token_get_reqversion (token_session_t *session);
char *token_get_respstatus (token_session_t *session);

char *token_get_headtype   (token_session_t *session, int *stop);
char *token_get_headvalue  (token_session_t *session);
char *token_get_column     (token_session_t *session);


unsigned char      *token_get_flush(token_session_t *session, int *lenght);

#endif 	    /* !TOKENLIB_H_ */
