/*
** http_peer.c
** Login : <julien@localhost>
** Started on  Fri Oct 21 00:07:12 2005 
** $Id$
** 
** Copyright Julien Perez (C) 2005 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/



#include "http_peer.h"
#include "vshlib.h"


static http_peer *lstpeers = NULL;
static nb_peer = 0;

int http_peer_add(char *hostname, int port)
{
  int        host_lenght;
  http_peer *new_peer, *tmp_peer;

  if (!hostname || !port)
    return 1;

  host_lenght = strlen(hostname);
  
  new_peer = vsh_malloc(sizeof(http_peer));
  new_peer->hostname = vsh_malloc(host_lenght + 1);
  strncpy(new_peer->hostname, hostname, host_lenght);
  new_peer->hostname[host_lenght] = 0;
  new_peer->port = port;

  nb_peer++;
  if (!lstpeers)
    {
      lstpeers = new_peer;
      return 0;
    }
  for(tmp_peer = lstpeers; tmp_peer->next; tmp_peer = tmp_peer->next) ;
  tmp_peer->next = new_peer;
  return 0;
}

int http_peer_getnb()
{
  return nb_peer;
}

http_peer *http_peer_get(int index)
{
  int i;
  http_peer *tmp_peer;

  for (i = 0, tmp_peer = lstpeers; 
       tmp_peer && i != index; 
       i++, tmp_peer = tmp_peer->next) ;
  
  return tmp_peer;
}
