/*
** spy_shape_cookie.c
** 
** Copyright Julien Perez (C) 2005 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/


#include "spy.h"
#include "conf.h"
#include "vshlib.h"
#include "http.h"
#include "http_methods.h"


int  spy_shape_cookie_policy_rule (char *rule)
{
  return 0;
}

int  spy_shape_cookie_init()
{
  return 0;
}


int spy_shape_resp_cookie (http_resp_t *resp, int log)
{
  char *cookie;
  http_field_t *tmp_field;

 
  /* Delete All Cookies */
 spy_shape_resp_fldcookie_start:
  for (tmp_field = resp->lst_fields; tmp_field; tmp_field = tmp_field->next)
    {
       if (tmp_field->type == FLD_COOKIE || tmp_field->type == FLD_SET_COOKIE)
	{
	  if (log)
	    spy_log("SHAPE_COOKIE", conf_get_node(CONF_LOG), 0);
	  resp->lst_fields = http_methods_rm_field(resp->lst_fields, tmp_field);
	  goto spy_shape_resp_fldcookie_start;
	}
    }
  return 1;
}


int spy_shape_req_cookie (http_req_t *req, int log)
{
  char *cookie;
  http_field_t *tmp_field;

  /* Delete All Cookies */
 spy_shape_req_fldcookie_start:
  for (tmp_field = req->lst_fields; tmp_field; tmp_field = tmp_field->next)
      if (tmp_field->type == FLD_COOKIE || tmp_field->type == FLD_SET_COOKIE)
	{
	  if (log)
	    spy_log("SHAPE_COOKIE", conf_get_node(CONF_LOG), 1);
	  req->lst_fields = http_methods_rm_field(req->lst_fields, tmp_field);
	  goto spy_shape_req_fldcookie_start;
	}
  return 1;
}
